## com.bbn.openmap.layer.link
Class LinkBitmap

    java.lang.Object
      com.bbn.openmap.layer.link.LinkBitmap

All Implemented Interfaces:
  LinkGraphicConstants, LinkPropertiesConstants

public class LinkBitmap
extends java.lang.Object
implements LinkGraphicConstants, LinkPropertiesConstants

Reading and writing the Link protocol version of a bitmap..

Field Summary

Fields inherited from interface com.bbn.openmap.layer.link.LinkGraphicConstants

`BASELINE_BOTTOM, BASELINE_MIDDLE, BASELINE_TOP, BLACK_COLOR_STRING, CLEAR_COLOR_STRING, COLORMODEL_DIRECT, COLORMODEL_INDEXED, COLORMODEL_URL, COLUMN_MAJOR, COORDMODE_ORIGIN, COORDMODE_PREVIOUS, DECIMAL_DEGREES, GRAPHICTYPE_ARC, GRAPHICTYPE_BITMAP, GRAPHICTYPE_CIRCLE, GRAPHICTYPE_ELLIPSE, GRAPHICTYPE_GRAPHIC, GRAPHICTYPE_GRID, GRAPHICTYPE_LINE, GRAPHICTYPE_POINT, GRAPHICTYPE_POLY, GRAPHICTYPE_RASTER, GRAPHICTYPE_RECTANGLE, GRAPHICTYPE_TEXT, JUSTIFY_CENTER, JUSTIFY_LEFT, JUSTIFY_RIGHT, KM, LINETYPE_GREATCIRCLE, LINETYPE_RHUMB, LINETYPE_STRAIGHT, LINETYPE_UNKNOWN, MILES, NMILES, RADIANS, RENDERTYPE_LATLON, RENDERTYPE_OFFSET, RENDERTYPE_UNKNOWN, RENDERTYPE_XY, ROW_MAJOR`

Fields inherited from interface com.bbn.openmap.layer.link.LinkPropertiesConstants

`LPC_BACKWARD_DIAG_PATTERN, LPC_CENTER_LAT, LPC_CENTER_LONG, LPC_CLEAR_PROPERTIES, LPC_CLEAR_PROPERTIES_CHAR, LPC_CROSS_PATTERN, LPC_DASH, LPC_DASH_DOT, LPC_DASH_DOT_DOT, LPC_DIAG_CROSS_PATTERN, LPC_DOT, LPC_FILLCOLOR, LPC_FILLPATTERN, LPC_FORWARD_DIAG_PATTERN, LPC_GRAPHICID, LPC_HEIGHT, LPC_HIGHLIGHTCOLOR, LPC_HORIZONTAL_PATTERN, LPC_HTML, LPC_INFO, LPC_LATMAX, LPC_LATMIN, LPC_LINECOLOR, LPC_LINESTYLE, LPC_LINEWIDTH, LPC_LINKRASTERIMAGEURL, LPC_LINKROTATION, LPC_LINKTEXTBASELINE, LPC_LINKTEXTFONT, LPC_LINKTEXTSTRING, LPC_LONG_DASH, LPC_LONMAX, LPC_LONMIN, LPC_MESSAGE, LPC_OLD_FILLCOLOR, LPC_OLD_FILLPATTERN, LPC_OLD_HIGHLIGHTCOLOR, LPC_OLD_LINECOLOR, LPC_OLD_LINESTYLE, LPC_OLD_LINEWIDTH, LPC_OLD_LINKTEXTFONT, LPC_OLD_LINKTEXTSTRING, LPC_PROJECTION, LPC_PROPERY_MANAGEMENT_POLICY, LPC_PROPERY_MANAGEMENT_POLICY_CHAR, LPC_REUSE_PROPERTIES, LPC_REUSE_PROPERTIES_CHAR, LPC_SCALE, LPC_SOLID, LPC_SOLID_PATTERN, LPC_TIME, LPC_URL, LPC_VERTICAL_PATTERN, LPC_WIDTH`

Constructor Summary
`LinkBitmap()`

Method Summary
`static OMBitmap` `read(java.io.DataInputStream dis)` Read a Bitmap off a DataInputStream.
`static OMBitmap` `read(java.io.DataInputStream dis, LinkProperties propertiesBuffer)` Read a Bitmap off a DataInputStream.
`static void` `write(float lt, float ln, int w, int h, byte[] bytes, LinkProperties properties, java.io.DataOutputStream dos)` Lat/Lon placement.
`static void` `write(float lt, float ln, int offset_x1, int offset_y1, int w, int h, byte[] bytes, LinkProperties properties, java.io.DataOutputStream dos)` Lat/lon placement with XY offset.
`static void` `write(int x1, int y1, int w, int h, byte[] bytes, LinkProperties properties, java.io.DataOutputStream dos)` XY placement.
`static void` `write(OMBitmap bitmap, Link link, LinkProperties props)` Write a bitmap to the link.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LinkBitmap

    public LinkBitmap()

Method Detail

### write

    public static void write(float lt,
                             float ln,
                             int w,
                             int h,
                             byte[] bytes,
                             LinkProperties properties,
                             java.io.DataOutputStream dos)
                      throws java.io.IOException

  Lat/Lon placement.

  Parameters:
    `lt` - latitude of the top of the image.
    `ln` - longitude of the left side of the image.
    `w` - width of the image, in pixels.
    `h` - height of the image, in pixels.
    `bytes` - bytes for the bitmap.
    `properties` - attributes for the bitmap.
    `dos` - DataOutputStream.
  Throws:
    `java.io.IOException`

### write

    public static void write(int x1,
                             int y1,
                             int w,
                             int h,
                             byte[] bytes,
                             LinkProperties properties,
                             java.io.DataOutputStream dos)
                      throws java.io.IOException

  XY placement.

  Parameters:
    `x1` - window location of the left side of the image.
    `y1` - window location of the top of the image.
    `w` - width of the image, in pixels.
    `h` - height of the image, in pixels.
    `bytes` - bytes for the bitmap.
    `properties` - attributes for the bitmap.
    `dos` - DataOutputStream.
  Throws:
    `java.io.IOException`

### write

    public static void write(float lt,
                             float ln,
                             int offset_x1,
                             int offset_y1,
                             int w,
                             int h,
                             byte[] bytes,
                             LinkProperties properties,
                             java.io.DataOutputStream dos)
                      throws java.io.IOException

  Lat/lon placement with XY offset.

  Parameters:
    `lt` - latitude of the top of the image, before the offset.
    `ln` - longitude of the left side of the image, before the offset.
    `offset_x1` - number of pixels to move image to the right.
    `offset_y1` - number of pixels to move image down.
    `w` - width of the image, in pixels.
    `h` - height of the image, in pixels.
    `bytes` - bytes for the bitmap.
    `properties` - attributes for the bitmap.
    `dos` - DataOutputStream.
  Throws:
    `java.io.IOException`

### write

    public static void write(OMBitmap bitmap,
                             Link link,
                             LinkProperties props)
                      throws java.io.IOException

  Write a bitmap to the link.

  Throws:
    `java.io.IOException`

### read

    public static OMBitmap read(java.io.DataInputStream dis)
                         throws java.io.IOException

  Read a Bitmap off a DataInputStream. Assumes the Bitmap header has already been read.

  Parameters:
    `dis` - DataInputStream to read from.
  Returns:
    OMBitmap
  Throws:
    `java.io.IOException`
  See Also:
    `OMBitmap`

### read

    public static OMBitmap read(java.io.DataInputStream dis,
                                LinkProperties propertiesBuffer)
                         throws java.io.IOException

  Read a Bitmap off a DataInputStream. Assumes the Bitmap header has already been read.

  Parameters:
    `dis` - DataInputStream to read from.
    `propertiesBuffer` - a LinkProperties object used to cache previous settings that can be set on the OMPoly being read.
  Returns:
    OMBitmap
  Throws:
    `java.io.IOException`
  See Also:
    `OMBitmap`

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details